/*
 * mas.c source file.
 * [sys,x0]=masrs(t,x,u,flag);
 *  Copyright (c) 1995 by Hub.
 * va,vb,vc et Cr en entree
 * id iq phi d phi q et omega en sortie
 *  All Rights Reserved
 */


#define S_FUNCTION_NAME mas
#include <math.h>
#include "mex.h"
#include "simstruc.h"

static void mdlInitializeSizes(SimStruct *S)
{
    ssSetNumContStates(    S, 5);      /* number of continuous states */
    ssSetNumDiscStates(    S, 0);      /* number of discrete states */
    ssSetNumInputs(        S, 4);      /* number of inputs */
    ssSetNumOutputs(       S, 5);      /* number of outputs */
    ssSetDirectFeedThrough(S, 0);      /* direct feedthrough flag */
    ssSetNumSampleTimes(   S, 1);      /* number of sample times */
    ssSetNumInputArgs(     S, 0);      /* number of input arguments */
    ssSetNumRWork(         S, 0);      /* number of real work vector elements */
    ssSetNumIWork(         S, 0);      /* number of integer work vector elements */
    ssSetNumPWork(         S, 0);      /* number of pointer work vector elements */
}

static void mdlInitializeSampleTimes(SimStruct *S)
{
    ssSetSampleTimeEvent(S, 0, 0.0);
    ssSetOffsetTimeEvent(S, 0, 0.0);
}

static void mdlInitializeConditions(double *x0, SimStruct *S)
{
	x0[0]=0.0;
	x0[1]=0.0;
	x0[2]=0.0;
	x0[3]=0.0;
	x0[4]=0.0;
}

static void mdlOutputs(double *y, double *x, double *u, SimStruct *S, int tid)
{ 
	y[0]=x[0];
	y[1]=x[1];
	y[2]=x[2]; 
	y[3]=x[3]; 
	y[4]=x[4];  
}

static void mdlUpdate(double *x, double *u, SimStruct *S, int tid)
{
}

static void mdlDerivatives(double *dx, double *x, double *u, SimStruct *S, int tid)
{
double *Rs,*sig,*Ls,*Rr,*Lr,*M,*p,*J;
double a1,a2,a3,a4,a5,a6,vd,vq;

	Rs=mxGetPr(mexGetMatrixPtr("Rs"));
	sig=mxGetPr(mexGetMatrixPtr("sig"));
	Ls=mxGetPr(mexGetMatrixPtr("Ls"));
	Rr=mxGetPr(mexGetMatrixPtr("Rr"));
	Lr=mxGetPr(mexGetMatrixPtr("Lr"));
	M =mxGetPr(mexGetMatrixPtr("M"));
	p =mxGetPr(mexGetMatrixPtr("p"));
	J =mxGetPr(mexGetMatrixPtr("J")); 
	a1=-1.0*(*Rs/(*sig**Ls)+(1.0-*sig)**Rr/(*sig**Lr));
	a2=*Rr/(*Lr);
	a3=*M/(*sig**Ls**Lr);
	a4=1.0/(*sig**Ls);
	vd = 0.81649658092773*u[0]-0.40854829046386*(u[1]+u[2]);
	vq = 0.70710678118655*(u[1]-u[2]);
	dx[0]=a1*x[0]+a3*(a2*x[2]+*p*x[4]*x[3])+vd*a4;
	dx[1]=a1*x[1]+a3*(a2*x[3]-*p*x[4]*x[2])+vq*a4;
	dx[2]=a2*(*M*x[0]-x[2])-*p*x[4]*x[3]; 
	dx[3]=a2*(*M*x[1]-x[3])+*p*x[4]*x[2]; 
	dx[4]=(*p**M/(*Lr)*(x[1]*x[2]-x[0]*x[3])-u[3])/(*J);  
}

static void mdlTerminate(SimStruct *S)
{
}

#ifdef  MATLAB_MEX_FILE    /* Is this file being compiled as a MEX-file? */
#include "simulink.c"      /* MEX-file interface mechanism */
#else
#include "cg_sfun.h"       /* Code generation registration function */
#endif
